--  Copyright (2008-2013) Cdric Coussinet (cedric.coussinet@nomoseed.net)
--
--  This program is free software: you can redistribute it and/or modify
--  it under the terms of the GNU Affero General Public License as published
--  by the Free Software Foundation, either version 3 of the License, or
--  (at your option) any later version.
--
--  This program is distributed in the hope that it will be useful,
--  but WITHOUT ANY WARRANTY; without even the implied warranty of
--  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
--  GNU Affero General Public License for more details.

--  You should have received a copy of the GNU Affero General Public License
--  along with this program. If not, see <http://www.gnu.org/licenses/>

with Nomo.Interpreter.Internal_Events.Checking;

package body Nomo.Interpreter.Internal_Events_Index.Registers.Checking is

   function Intentions_Present (This : in Internal_Register) return Boolean is
   begin
      return This.Last_Intention /= This.Current_Evidence;
   end Intentions_Present;

   function Is_Ongoing (This        : in Internal_Register;
                        Information : in Positive_Integer) return Boolean is
     use Internal_Events.Checking;
   begin
      return Information_Equal (This.Trace (Internal_Event_Index (Natural (This.Current_Evidence + 1) mod Index_Modulo)), Information)
      and then Not_Immediat_Information (This.Trace (This.Current_Evidence), Information);
   end Is_Ongoing;

end Nomo.Interpreter.Internal_Events_Index.Registers.Checking;
